#pragma once

#include<iostream>
#include <fstream>
#include<stdlib.h>
#include<vector>
#include<random>
#include<math.h>
#include<time.h>
#include<string>
#include "OptimizationProblemInterface.h"
#include "OptimizerInterface.h"
#include<chrono>

using namespace std;

class DifferentialEvolution : public OptimizerInterface {
public:
	DifferentialEvolution(OptimizationProblemInterface* op, int g_max, int np, double Cr);
	virtual ~DifferentialEvolution();
	vector<double> startAlgorithm();
private:
	int g_max;//Maximum generations
	int np;//Population size

	OptimizationProblemInterface* op;//Optimization problem
	vector<vector<double>> x;//Population matrix
	vector<double> f_x;//Objective function values of population
	vector<double> g_x;//Constraint sums of population

	
	double scaledRand();//Return a random number in [0,1]
	void initializePopulation();//Generate a new population
	double F;//Scaling factor (randomly generated widthin [0.3,0.9])
	double Cr;//Crossover rate

	vector<double> d_min;//Lower bounds
	vector<double> d_max;//Upper bounds
	int d;//Problem dimensionality

	//Random Number Generator
	mt19937 rng;
	uniform_real_distribution<double> dist;
};

