#pragma once
#include "ObstacleInterface.h"
#include<vector>

//Predefined moves of the obstacles
#define SIN_Y_PATH 0 //Vertical sine
#define COS_Y_PATH 1 //Vertical cosine
#define SIN_X_PATH 2 //Horizontal sine
#define COS_X_PATH 3 //Horizontal cosine
#define CIRCLE_PATH 4 //Circle

using namespace std;

class Obstacle : public ObstacleInterface {
public:
	Obstacle(double r, double x, double y, int pathType, double period, double amplitude);
	Obstacle();
	vector<double> getPosition(double t);
	double getR();
	virtual ~Obstacle();
private:
	double r;//Obstacle radius
	double x;//Obstacle initial x coordinate
	double y;//Obstacle initial y coordinate
	int pathType;//Path time (from the predefined list)
	double period;//Period
	double amplitude;//Amplitude
};

